#
# TimerTest.rb
# (c) by Dan Rathbun, 06 MAR 2010 Palm Bay, Florida USA
# ALL RIGHTS RESERVED by Author
# Terms: Non-Commercial Use ONLY
# NO Warranties Expressed or Implied

# put in Plugins/test folder
# at console:
# load 'test/TimerTest.rb'

module SU_test
  module Timer
  
    @@cmd1=nil; @@cmd2=nil; @@cmd3=nil; @@mnuTest=nil

    # Tests the Sketchup UI module timer
    def self.timerTestUI(float=0.5)
      Sketchup.send_action(CMD_RUBY_CONSOLE)
      t0=Time.now
      UI.start_timer(float, false) {
        t1=Time.now
        dur=(t1-t0).to_s
        puts("\n")
        puts('-Timer Test for UI.start_timer -----------')
        puts(' You entered : '+float.to_s)
        puts(' Duration was: '+dur)
        puts('------------------------------------------')
      }
    end

    # Tests the Ruby Kernel.sleep timer
    def self.timerTestSleep(float=0.5);
      # make sure float is NEVER zero !!
      float=0.5 if float==0
      Sketchup.send_action(CMD_RUBY_CONSOLE)
      t0=Time.now
      dur = Kernel.sleep(float)
      t1=Time.now
      puts("\n")
      puts('-Timer Test for Kernel.sleep -------------')
      puts(' You entered : '+float.to_s)
      #puts(' Kernel.sleep reports an integer')
      #puts('     rounded Duration of: '+dur.to_s)
      dur=(t1-t0).to_s
      puts(' Duration was: '+dur)
      puts('------------------------------------------')
      #
    end

    # Lists incremental times for Ruby Kernel.sleep timer
    def self.timerListSleep(float=0.01,limit=2.0);
      # make sure float is NEVER zero !!
      float=0.01 if float==0
      Sketchup.send_action(CMD_RUBY_CONSOLE)
      Kernel.sleep(1)
      limit = limit + float
      i = 0.0 + float
      puts("\n")
      puts('-Timer Test for Kernel.sleep -------------')
       puts('  SleepArg     Duration')
      while i < limit do
        t0=Time.now
        dur = Kernel.sleep(i)
        t1=Time.now
        dur=(t1-t0)
        printf("  %f  :  %f",i,dur)
        puts("\n")
        i = i + float
      end
      puts('------------------------------------------')
      #
    end
    
  if $loaded_files.nil? then $loaded_files=[]; end
  unless $loaded_files.include?(File.basename(__FILE__))

    @@mnuTest = UI.menu('Plugins').add_submenu('Ruby Tests') if not @@mnuTest
    if not @@cmd1
      @@cmd1 = @@mnuTest.add_item('Timer Test - UI') do
        dur = UI.inputbox( ['Time(secs):'],[0.5],'Timer Test - UI.start_timer')[0]
        self.timerTestUI( dur )
      end
    end

    if not @@cmd2
      @@cmd2 = @@mnuTest.add_item('Timer Test - sleep') do
        dur = UI.inputbox( ['Time(secs):'],[0.5],'Timer Test - Kernel.sleep')[0]
        self.timerTestSleep( dur )
      end
    end

    if not @@cmd3
      @@cmd3 = @@mnuTest.add_item('Timer List - sleep') do
        ret = UI.inputbox( ['Step(secs):','Limit(secs)'],[0.01,2.0],'Timer List - Kernel.sleep')
        self.timerListSleep( ret[0],ret[1] )
      end
    end

    $loaded_files.push(File.basename(__FILE__))
  end
    
  end # Timer
end # SU_test